Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -2637,42 +2706,44 @@
     case WRITE_IDLE:  // copy first word of a write burst in local buffer
     {
-      if(m_cmd_write_addr_fifo.rok())
-      {
-        if((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
-          m_cpt_sc++;
-        else
-        {
-          m_cpt_write++;
-          m_cpt_write_cells++;
-        }
-
-        // consume a word in the FIFO & write it in the local buffer
-        cmd_write_fifo_get  = true;
-        size_t index        = m_x[(addr_t)(m_cmd_write_addr_fifo.read())];
-
-        r_write_address     = (addr_t)(m_cmd_write_addr_fifo.read());
-        r_write_word_index  = index;
-        r_write_word_count  = 1;
-        r_write_data[index] = m_cmd_write_data_fifo.read();
-        r_write_srcid       = m_cmd_write_srcid_fifo.read();
-        r_write_trdid       = m_cmd_write_trdid_fifo.read();
-        r_write_pktid       = m_cmd_write_pktid_fifo.read();
-        r_write_pending_sc  = false;
-
-        // initialize the be field for all words
-        for(size_t word=0 ; word<m_words ; word++)
-        {
-          if(word == index) r_write_be[word] = m_cmd_write_be_fifo.read();
-          else              r_write_be[word] = 0x0;
-        }
-
-        if (m_cmd_write_eop_fifo.read() or ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC))
-        {
-          r_write_fsm = WRITE_DIR_REQ;
-        }
-        else
-        {
-          r_write_fsm = WRITE_NEXT;
-        }
+        if(m_cmd_write_addr_fifo.rok())
+        {
+            if((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
+            {
+                m_cpt_sc++;
+            }
+            else
+            { 
+                m_cpt_write++;
+                m_cpt_write_cells++;
+            }
+
+            // consume a word in the FIFO & write it in the local buffer
+            cmd_write_fifo_get  = true;
+            size_t index        = m_x[(addr_t)(m_cmd_write_addr_fifo.read())];
+
+            r_write_address     = (addr_t)(m_cmd_write_addr_fifo.read());
+            r_write_word_index  = index;
+            r_write_word_count  = 1;
+            r_write_data[index] = m_cmd_write_data_fifo.read();
+            r_write_srcid       = m_cmd_write_srcid_fifo.read();
+            r_write_trdid       = m_cmd_write_trdid_fifo.read();
+            r_write_pktid       = m_cmd_write_pktid_fifo.read();
+            r_write_pending_sc  = false;
+
+            // initialize the be field for all words
+            for(size_t word=0 ; word<m_words ; word++)
+            {
+                if(word == index) r_write_be[word] = m_cmd_write_be_fifo.read();
+                else              r_write_be[word] = 0x0;
+            }
+
+            if (m_cmd_write_eop_fifo.read() or ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC))
+            {
+                r_write_fsm = WRITE_DIR_REQ;
+            }
+            else
+            {
+                r_write_fsm = WRITE_NEXT;
+            }
 
 #if DEBUG_MEMC_WRITE
@@ -2683,13 +2754,12 @@
           << " / data = " << m_cmd_write_data_fifo.read() << std::endl;
 #endif
-      }
-      break;
-    }
-
+        }
+        break;
+    }
     ////////////////
     case WRITE_NEXT:  // copy next word of a write burst in local buffer
     {
-      if(m_cmd_write_addr_fifo.rok())
-      {
+        if(m_cmd_write_addr_fifo.rok())
+        {
 
 #if DEBUG_MEMC_WRITE
@@ -2699,79 +2769,62 @@
           << std::endl;
 #endif
-        m_cpt_write_cells++;
-
-        // check that the next word is in the same cache line
-        if((m_nline[(addr_t)(r_write_address.read())]       !=
-            m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]))
-        {
-          std::cout << "VCI_MEM_CACHE ERROR " << name() << " WRITE_NEXT state" << std::endl
-                    << "all words in a write burst must be in same cache line" << std::endl;
-
-          exit(0);
-        }
-
-        // consume a word in the FIFO & write it in the local buffer
-        cmd_write_fifo_get  = true;
-        size_t index        = r_write_word_index.read() + r_write_word_count.read();
-
-        r_write_be[index]   = m_cmd_write_be_fifo.read();
-        r_write_data[index] = m_cmd_write_data_fifo.read();
-        r_write_word_count  = r_write_word_count.read() + 1;
-
-        if(m_cmd_write_eop_fifo.read())
-        {
-          r_write_fsm = WRITE_DIR_REQ;
-        }
-      }
-      break;
-    }
-
-    ////////////////////
-    case WRITE_DIR_REQ:
-    {
-      // Get the lock to the directory
-      // and access the llsc_global_table
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE)
-      {
-        ///////////////////////////////////////////////////////////////////////
-        // SC command treatment
-        // We test the r_write_pending_sc register to know if we are returning
-        // from the WAIT state.
-        // In this case, the SC has already succeed and we cannot consume
-        // another time from the FIFO. Also, we don't have to test another
-        // time if the SC has succeed
-        if(((r_write_pktid.read() & 0x7) == TYPE_SC) and not r_write_pending_sc.read())
-        {
-          if(not m_cmd_write_addr_fifo.rok()) break;
-
-          assert(m_cmd_write_eop_fifo.read() and
-                 "Error in VCI_MEM_CACHE : "
-                 "invalid packet format for SC command");
-
-          size_t index    = r_write_word_index.read();
-          bool sc_success = m_llsc_table.sc(r_write_address.read()    ,
+            m_cpt_write_cells++;
+
+            // check that the next word is in the same cache line
+            assert( (m_nline[(addr_t)(r_write_address.read())] == 
+                     m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]) and
+            "MEMC ERROR in WRITE_NEXT state: Illegal write burst");
+
+            // consume a word in the FIFO & write it in the local buffer
+            cmd_write_fifo_get  = true;
+            size_t index        = r_write_word_index.read() + r_write_word_count.read();
+
+            r_write_be[index]   = m_cmd_write_be_fifo.read();
+            r_write_data[index] = m_cmd_write_data_fifo.read();
+            r_write_word_count  = r_write_word_count.read() + 1;
+
+            if(m_cmd_write_eop_fifo.read()) r_write_fsm = WRITE_DIR_REQ;
+        }
+        break;
+    }
+    ///////////////////
+    case WRITE_DIR_REQ:    // Get the lock to the directory
+                           // and access the llsc_global_table
+    {
+        if( r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE )
+        {
+            if(((r_write_pktid.read() & 0x7) == TYPE_SC) and not r_write_pending_sc.read())
+            {
+                // We enter here if it is a new SC command
+                // If r_write_pending_sc is set the SC is not new and has already been tested
+
+                if(not m_cmd_write_addr_fifo.rok()) break;
+
+                assert( m_cmd_write_eop_fifo.read() and
+                "MEMC ERROR in WRITE_DIR_REQ state: invalid packet format for SC command");
+
+                size_t index    = r_write_word_index.read();
+                bool sc_success = m_llsc_table.sc(r_write_address.read()    ,
                                             r_write_data[index].read());
 
-          // consume a word in the FIFO & write it in the local buffer
-          cmd_write_fifo_get  = true;
-          r_write_data[index] = m_cmd_write_data_fifo.read();
-          r_write_sc_fail     = not sc_success;
-          r_write_pending_sc  = true;
-
-          if(not sc_success) r_write_fsm = WRITE_RSP;
-          else               r_write_fsm = WRITE_DIR_LOCK;
-
-          break;
-        }
-
-        ///////////////////////////////////////////////////////////////////////
-        // WRITE command treatment or SC command returning from the WAIT state
-        // In the second case, we must access the LL/SC global table to
-        // erase any possible new reservation when we release the lock on the
-        // directory
-        m_llsc_table.sw(m_nline[(addr_t)r_write_address.read()],r_write_word_index.read(),r_write_word_index.read()+r_write_word_count.read());
-
-        r_write_fsm = WRITE_DIR_LOCK;
-        m_cpt_write_fsm_n_dir_lock++;
+                // consume a word in the FIFO & write it in the local buffer
+                cmd_write_fifo_get  = true;
+                r_write_data[index] = m_cmd_write_data_fifo.read();
+                r_write_sc_fail     = not sc_success;
+                r_write_pending_sc  = true;
+
+                if(not sc_success) r_write_fsm = WRITE_RSP;
+                else               r_write_fsm = WRITE_DIR_LOCK;
+            }
+            else
+            {
+                // We enter here if it is a SW command or an already tested SC command 
+
+                m_llsc_table.sw( m_nline[(addr_t)r_write_address.read()],
+                                 r_write_word_index.read(),
+                                 r_write_word_index.read() + r_write_word_count.read() );
+
+                r_write_fsm = WRITE_DIR_LOCK;
+            }
       }
 
@@ -2781,15 +2834,12 @@
           << std::endl;
 #endif
-
-      m_cpt_write_fsm_dir_lock++;
-
       break;
     }
-
     ////////////////////
     case WRITE_DIR_LOCK:     // access directory to check hit/miss
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE)
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in ALLOC_DIR_LOCK state: Bad DIR allocation");
+
         size_t  way = 0;
         DirectoryEntry entry(m_cache_directory.read(r_write_address.read(), way));
@@ -2797,29 +2847,20 @@
         if(entry.valid)    // hit
         {
-          // copy directory entry in local buffer in case of hit
-          r_write_is_cnt     = entry.is_cnt;
-          r_write_lock       = entry.lock;
-          r_write_tag        = entry.tag;
-          r_write_copy       = entry.owner.srcid;
-#if L1_MULTI_CACHE
-          r_write_copy_cache = entry.owner.cache_id;
-#endif
-          r_write_copy_inst  = entry.owner.inst;
-          r_write_count      = entry.count;
-          r_write_ptr        = entry.ptr;
-          r_write_way        = way;
-
-          if(entry.is_cnt and entry.count)
-          {
-            r_write_fsm = WRITE_DIR_READ;
-          }
-          else
-          {
-            r_write_fsm = WRITE_DIR_HIT;
-          }
+            // copy directory entry in local buffer in case of hit
+            r_write_is_cnt     = entry.is_cnt;
+            r_write_lock       = entry.lock;
+            r_write_tag        = entry.tag;
+            r_write_copy       = entry.owner.srcid;
+            r_write_copy_inst  = entry.owner.inst;
+            r_write_count      = entry.count;
+            r_write_ptr        = entry.ptr;
+            r_write_way        = way;
+
+            if(entry.is_cnt and entry.count) r_write_fsm = WRITE_BC_DIR_READ;
+            else                             r_write_fsm = WRITE_DIR_HIT;
         }
         else  // miss
         {
-          r_write_fsm = WRITE_MISS_TRT_LOCK;
+            r_write_fsm = WRITE_MISS_TRT_LOCK;
         }
 
@@ -2838,207 +2879,145 @@
 }
 #endif
-      }
-      else
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name()
-                  << " WRITE_DIR_LOCK state"        << std::endl
-                  << "bad DIR allocation"           << std::endl;
-
-        exit(0);
-      }
-      break;
-    }
-    ////////////////////
-    case WRITE_DIR_READ:  // read the cache and complete the buffer when be!=0xF
-    {
-      // update local buffer
-      size_t set  = m_y[(addr_t)(r_write_address.read())];
-      size_t way  = r_write_way.read();
-      for(size_t word=0 ; word<m_words ; word++)
-      {
-        data_t mask = 0;
-        if(r_write_be[word].read() & 0x1) mask = mask | 0x000000FF;
-        if(r_write_be[word].read() & 0x2) mask = mask | 0x0000FF00;
-        if(r_write_be[word].read() & 0x4) mask = mask | 0x00FF0000;
-        if(r_write_be[word].read() & 0x8) mask = mask | 0xFF000000;
-
-        // complete only if mask is not null (for energy consumption)
-        r_write_data[word]  = (r_write_data[word].read() & mask) |
-                              (m_cache_data.read(way, set, word) & ~mask);
-
-      } // end for
-
-      // test if a coherence broadcast is required
-      r_write_fsm = WRITE_BC_TRT_LOCK;
-
-#if DEBUG_MEMC_WRITE
-if(m_debug)
-std::cout << "  <MEMC " << name() << " WRITE_DIR_READ>"
-          << " Read the cache to complete local buffer" << std::endl;
-#endif
-      break;
-    }
-
+        break;
+    }
     ///////////////////
-    case WRITE_DIR_HIT:
-    {
-      // update the cache directory
-      // update directory with Dirty bit
-      DirectoryEntry entry;
-      entry.valid          = true;
-      entry.dirty          = true;
-      entry.tag            = r_write_tag.read();
-      entry.is_cnt         = r_write_is_cnt.read();
-      entry.lock           = r_write_lock.read();
-      entry.owner.srcid    = r_write_copy.read();
-#if L1_MULTI_CACHE
-      entry.owner.cache_id = r_write_copy_cache.read();
-#endif
-      entry.owner.inst     = r_write_copy_inst.read();
-      entry.count          = r_write_count.read();
-      entry.ptr            = r_write_ptr.read();
-
-      size_t set           = m_y[(addr_t)(r_write_address.read())];
-      size_t way           = r_write_way.read();
-
-      // update directory
-      m_cache_directory.write(set, way, entry);
-
-      // owner is true when the  the first registered copy is the writer itself
-      bool owner = (((r_write_copy.read() == r_write_srcid.read())
-#if L1_MULTI_CACHE
-                     and(r_write_copy_cache.read() ==r_write_pktid.read())
-#endif
-                    ) and not r_write_copy_inst.read());
-
-      // no_update is true when there is no need for coherence transaction
-      // (tests for sc requests)
-      bool no_update = ( (r_write_count.read() == 0) or
+    case WRITE_DIR_HIT:    // update the cache directory with Dirty bit
+                           // and update data cache
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in ALLOC_DIR_HIT state: Bad DIR allocation");
+
+        DirectoryEntry entry;
+        entry.valid          = true;
+        entry.dirty          = true;
+        entry.tag            = r_write_tag.read();
+        entry.is_cnt         = r_write_is_cnt.read();
+        entry.lock           = r_write_lock.read();
+        entry.owner.srcid    = r_write_copy.read();
+        entry.owner.inst     = r_write_copy_inst.read();
+        entry.count          = r_write_count.read();
+        entry.ptr            = r_write_ptr.read();
+
+        size_t set           = m_y[(addr_t)(r_write_address.read())];
+        size_t way           = r_write_way.read();
+
+        // update directory
+        m_cache_directory.write(set, way, entry);
+
+        // owner is true when the  the first registered copy is the writer itself
+        bool owner = ( (r_write_copy.read() == r_write_srcid.read())
+                     and not r_write_copy_inst.read() );
+
+        // no_update is true when there is no need for coherence transaction
+        bool no_update = ( (r_write_count.read() == 0) or
                          (owner and (r_write_count.read() ==1) and 
                          (r_write_pktid.read() != TYPE_SC)));
 
-      // write data in the cache if no coherence transaction
-      if(no_update)
-      {
-        for(size_t word=0 ; word<m_words ; word++)
-        {
-          m_cache_data.write(way, set, word, r_write_data[word].read(), r_write_be[word].read());
-
-          if(m_monitor_ok)
-          {
-            addr_t address = (r_write_address.read() & ~(addr_t) 0x3F) | word<<2;
-            check_monitor( address, r_write_data[word].read(), false);
-          }
-        }
-      }
-
-      if(owner and not no_update and(r_write_pktid.read() != TYPE_SC))
-      {
-        r_write_count = r_write_count.read() - 1;
-      }
-
-      if(no_update)
-      // Write transaction completed
-      {
-        r_write_fsm = WRITE_RSP;
-      }
-      else
-      // coherence update required
-      {
-        if(!r_write_to_cc_send_multi_req.read() and
-           !r_write_to_cc_send_brdcast_req.read())
-        {
-          r_write_fsm = WRITE_UPT_LOCK;
-        }
-        else
-        {
-          r_write_fsm = WRITE_WAIT;
-        }
-      }
+        // write data in the cache if no coherence transaction
+        if(no_update)
+        {
+            for(size_t word=0 ; word<m_words ; word++)
+            {
+                m_cache_data.write( way, 
+                                    set, 
+                                    word, 
+                                    r_write_data[word].read(), 
+                                    r_write_be[word].read());
+            }
+        }
+
+        if(owner and not no_update and(r_write_pktid.read() != TYPE_SC))
+        {
+            r_write_count = r_write_count.read() - 1;
+        }
+
+        if(no_update)     // Write transaction completed
+        {
+            r_write_fsm = WRITE_RSP;
+        }
+        else              // coherence update required
+        {
+            if(!r_write_to_cc_send_multi_req.read() and
+               !r_write_to_cc_send_brdcast_req.read())
+            {
+                r_write_fsm = WRITE_UPT_LOCK;
+            }
+            else
+            {
+                r_write_fsm = WRITE_WAIT;
+            }
+        }
 
 #if DEBUG_MEMC_WRITE
 if(m_debug)
 {
-    if(no_update)
-    {
-        std::cout << "  <MEMC " << name() 
-                  << " WRITE_DIR_HIT> Write into cache / No coherence transaction"
-                  << std::endl;
-    }
-    else
-    {
-        std::cout << "  <MEMC " << name() << " WRITE_DIR_HIT> Coherence update required:"
-                  << " is_cnt = " << r_write_is_cnt.read()
-                  << " nb_copies = " << std::dec << r_write_count.read() << std::endl;
-        if(owner) std::cout << "       ... but the first copy is the writer" << std::endl;
-    }
+if(no_update)
+{
+std::cout << "  <MEMC " << name() 
+          << " WRITE_DIR_HIT> Write into cache / No coherence transaction" << std::endl;
 }
-#endif
-      break;
+else
+{
+std::cout << "  <MEMC " << name() << " WRITE_DIR_HIT> Coherence update required:"
+          << " is_cnt = " << r_write_is_cnt.read()
+          << " nb_copies = " << std::dec << r_write_count.read() << std::endl;
+if(owner) std::cout << "       ... but the first copy is the writer" << std::endl;
+}
+}
+#endif
+        break;
     }
     ////////////////////
     case WRITE_UPT_LOCK:  // Try to register the update request in UPT
     {
-      if(r_alloc_upt_fsm.read() == ALLOC_UPT_WRITE)
-      {
-        bool        wok        = false;
-        size_t      index      = 0;
-        size_t      srcid      = r_write_srcid.read();
-        size_t      trdid      = r_write_trdid.read();
-        size_t      pktid      = r_write_pktid.read();
-        addr_t      nline      = m_nline[(addr_t)(r_write_address.read())];
-        size_t      nb_copies  = r_write_count.read();
-        size_t      set        = m_y[(addr_t)(r_write_address.read())];
-        size_t      way        = r_write_way.read();
-
-        wok = m_upt.set(true,  // it's an update transaction
-                        false, // it's not a broadcast
-                        true,  // response required
-                        false, // no acknowledge required
-                        srcid,    
-                        trdid,
-                        pktid,
-                        nline,
-                        nb_copies,
-                        index);
-        if(wok)       // write data in cache
-        {
-          for(size_t word=0 ; word<m_words ; word++)
-          {
-            m_cache_data.write(way,
-                               set,
-                               word,
-                               r_write_data[word].read(),
-                               r_write_be[word].read());
-
-            if(m_monitor_ok)
+        if(r_alloc_upt_fsm.read() == ALLOC_UPT_WRITE)
+        {
+            bool        wok        = false;
+            size_t      index      = 0;
+            size_t      srcid      = r_write_srcid.read();
+            size_t      trdid      = r_write_trdid.read();
+            size_t      pktid      = r_write_pktid.read();
+            addr_t      nline      = m_nline[(addr_t)(r_write_address.read())];
+            size_t      nb_copies  = r_write_count.read();
+            size_t      set        = m_y[(addr_t)(r_write_address.read())];
+            size_t      way        = r_write_way.read();
+
+            wok = m_upt.set( true,  // it's an update transaction
+                             false, // it's not a broadcast
+                             true,  // response required
+                             false, // no acknowledge required
+                             srcid,    
+                             trdid,
+                             pktid,
+                             nline,
+                             nb_copies,
+                             index);
+
+            if( wok )       // write data in cache
             {
-              addr_t address = (r_write_address.read() & ~(addr_t) 0x3F) | word<<2;
-              check_monitor( address, r_write_data[word].read(), false);
+                for(size_t word=0 ; word<m_words ; word++)
+                {
+                    m_cache_data.write( way,
+                                        set,
+                                        word,
+                                        r_write_data[word].read(),
+                                        r_write_be[word].read());
+                }
             }
-          }
-        }
 
 #if DEBUG_MEMC_WRITE
-if(m_debug)
+if(m_debug and wok)
 {
-    if(wok)
-    {
-        std::cout << "  <MEMC " << name() 
-                  << " WRITE_UPT_LOCK> Register the multicast update in UPT / "
-                  << " nb_copies = " << r_write_count.read() << std::endl;
-    }
+std::cout << "  <MEMC " << name() 
+          << " WRITE_UPT_LOCK> Register the multicast update in UPT / "
+          << " nb_copies = " << r_write_count.read() << std::endl;
 }
 #endif
-        r_write_upt_index = index;
-        //  releases the lock protecting UPT and the DIR if no entry...
-        if(wok) r_write_fsm = WRITE_UPT_HEAP_LOCK;
-        else    r_write_fsm = WRITE_WAIT;
-        m_cpt_write_fsm_n_upt_lock++;
-      }
-
-      m_cpt_write_fsm_upt_lock++;
-
-      break;
+            r_write_upt_index = index;
+            // releases the lock protecting UPT and the DIR if no entry...
+            if(wok) r_write_fsm = WRITE_UPT_HEAP_LOCK;
+            else    r_write_fsm = WRITE_WAIT;
+        }
+        break;
     }
 
@@ -3086,9 +3065,6 @@
       for(size_t i=min ; i<max ; i++) r_write_to_cc_send_data[i] = r_write_data[i];
 
-      if((r_write_copy.read() != r_write_srcid.read()) or(r_write_pktid.read() == TYPE_SC) or
-#if L1_MULTI_CACHE
-          (r_write_copy_cache.read() != r_write_pktid.read()) or
-#endif
-          r_write_copy_inst.read())
+      if( (r_write_copy.read() != r_write_srcid.read()) or
+          (r_write_pktid.read() == TYPE_SC) or r_write_copy_inst.read())
       {
         // put the first srcid in the fifo
@@ -3096,7 +3072,4 @@
         write_to_cc_send_fifo_inst    = r_write_copy_inst.read();
         write_to_cc_send_fifo_srcid   = r_write_copy.read();
-#if L1_MULTI_CACHE
-        write_to_cc_send_fifo_cache_id= r_write_copy_cache.read();
-#endif
         if(r_write_count.read() == 1)
         {
@@ -3149,9 +3122,7 @@
       bool dec_upt_counter;
 
-      if(((entry.owner.srcid != r_write_srcid.read()) or (r_write_pktid.read() == TYPE_SC)) or
-#if L1_MULTI_CACHE
-          (entry.owner.cache_id != r_write_pktid.read()) or
-#endif
-          entry.owner.inst)             // put the next srcid in the fifo
+      // put the next srcid in the fifo
+      if( (entry.owner.srcid != r_write_srcid.read()) or 
+          (r_write_pktid.read() == TYPE_SC) or entry.owner.inst)   
       {
         dec_upt_counter                = false;
@@ -3159,7 +3130,4 @@
         write_to_cc_send_fifo_inst     = entry.owner.inst;
         write_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        write_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
 
 #if DEBUG_MEMC_WRITE
@@ -3231,11 +3199,9 @@
 
     ///////////////
-    case WRITE_RSP:
-    {
-      // Post a request to TGT_RSP FSM to acknowledge the write
-      // In order to increase the Write requests throughput,
-      // we don't wait to return in the IDLE state to consume
-      // a new request in the write FIFO
-
+    case WRITE_RSP:  // Post a request to TGT_RSP FSM to acknowledge the write
+                     // In order to increase the Write requests throughput,
+                     // we don't wait to return in the IDLE state to consume
+                     // a new request in the write FIFO
+    {
       if(!r_write_to_tgt_rsp_req.read())
       {
@@ -3330,5 +3296,5 @@
         bool    hit_write = m_trt.hit_write(m_nline[addr]);
 #endif
-        bool    wok       = !m_trt.full(wok_index);
+        bool    wok       = not m_trt.full(wok_index);
 
         if(hit_read)      // register the modified data in TRT
@@ -3418,7 +3384,7 @@
           data_vector.push_back(r_write_data[i]);
         }
-        m_trt.write_data_mask(r_write_trt_index.read(),
-                                          be_vector,
-                                          data_vector);
+        m_trt.write_data_mask( r_write_trt_index.read(),
+                               be_vector,
+                               data_vector );
         r_write_fsm = WRITE_RSP;
 
@@ -3430,14 +3396,12 @@
       break;
     }
-
     /////////////////////////
     case WRITE_MISS_XRAM_REQ: // send a GET request to IXR_CMD FSM
     {
-      if(!r_write_to_ixr_cmd_req)
+      if( not r_write_to_ixr_cmd_req.read() )
       {
         r_write_to_ixr_cmd_req   = true;
-        r_write_to_ixr_cmd_write = false;
-        r_write_to_ixr_cmd_nline = m_nline[(addr_t)(r_write_address.read())];
-        r_write_to_ixr_cmd_trdid = r_write_trt_index.read();
+        r_write_to_ixr_cmd_put   = false;
+        r_write_to_ixr_cmd_index = r_write_trt_index.read();
         r_write_fsm              = WRITE_RSP;
 
@@ -3449,21 +3413,56 @@
       break;
     }
-
     ///////////////////////
-    case WRITE_BC_TRT_LOCK:     // Check TRT not full
-    {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE)
-      {
-        size_t wok_index = 0;
-        bool wok = !m_trt.full(wok_index);
-        if(wok)       // set a new entry in TRT
-        {
-          r_write_trt_index = wok_index;
-          r_write_fsm       = WRITE_BC_IVT_LOCK;
-        }
-        else  // wait an empty entry in TRT
-        {
-          r_write_fsm       = WRITE_WAIT;
-        }
+    case WRITE_BC_DIR_READ:  // enter this state if a broadcast-inval is required
+                             // the cache line must be erased in mem-cache, and written
+                             // into XRAM. we read the cache and complete the buffer
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in WRITE_BC_DIR_READ state: Bad DIR allocation");
+ 
+        // update local buffer
+        size_t set  = m_y[(addr_t)(r_write_address.read())];
+        size_t way  = r_write_way.read();
+        for(size_t word=0 ; word<m_words ; word++)
+        {
+            data_t mask = 0;
+            if(r_write_be[word].read() & 0x1) mask = mask | 0x000000FF;
+            if(r_write_be[word].read() & 0x2) mask = mask | 0x0000FF00;
+            if(r_write_be[word].read() & 0x4) mask = mask | 0x00FF0000;
+            if(r_write_be[word].read() & 0x8) mask = mask | 0xFF000000;
+
+            // complete only if mask is not null (for energy consumption)
+            r_write_data[word]  = (r_write_data[word].read() & mask) |
+                                  (m_cache_data.read(way, set, word) & ~mask);
+        } // end for
+
+        r_write_fsm = WRITE_BC_TRT_LOCK;
+
+#if DEBUG_MEMC_WRITE
+if(m_debug)
+std::cout << "  <MEMC " << name() << " WRITE_BC_DIR_READ>"
+          << " Read the cache to complete local buffer" << std::endl;
+#endif
+        break;
+    }
+    ///////////////////////
+    case WRITE_BC_TRT_LOCK:     // get TRT lock to check TRT not full
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in WRITE_BC_TRT_LOCK state: Bad DIR allocation");
+ 
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE)
+        {
+            size_t wok_index = 0;
+            bool wok = not m_trt.full(wok_index);
+            if( wok )       
+            {
+                r_write_trt_index = wok_index;
+                r_write_fsm       = WRITE_BC_IVT_LOCK;
+            }
+            else  // wait an empty slot in TRT
+            {
+                r_write_fsm       = WRITE_WAIT;
+            }
 
 #if DEBUG_MEMC_WRITE
@@ -3479,28 +3478,33 @@
       break;
     }
-
     //////////////////////
-    case WRITE_BC_IVT_LOCK:      // register BC transaction in IVT
-    {
-      if(r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE)
-      {
-        bool        wok       = false;
-        size_t      index     = 0;
-        size_t      srcid     = r_write_srcid.read();
-        size_t      trdid     = r_write_trdid.read();
-        size_t      pktid     = r_write_pktid.read();
-        addr_t      nline     = m_nline[(addr_t)(r_write_address.read())];
-        size_t      nb_copies = r_write_count.read();
-
-        wok = m_ivt.set(false,  // it's an inval transaction
-                        true,   // it's a broadcast
-                        true,   // response required
-                        false,  // no acknowledge required
-                        srcid,
-                        trdid,
-                        pktid,
-                        nline,
-                        nb_copies,
-                        index);
+    case WRITE_BC_IVT_LOCK:      // get IVT lock and register BC transaction in IVT
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+        "MEMC ERROR in WRITE_BC_IVT_LOCK state: Bad DIR allocation");
+ 
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE) and
+        "MEMC ERROR in WRITE_BC_IVT_LOCK state: Bad TRT allocation");
+ 
+        if(r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE)
+        {
+            bool        wok       = false;
+            size_t      index     = 0;
+            size_t      srcid     = r_write_srcid.read();
+            size_t      trdid     = r_write_trdid.read();
+            size_t      pktid     = r_write_pktid.read();
+            addr_t      nline     = m_nline[(addr_t)(r_write_address.read())];
+            size_t      nb_copies = r_write_count.read();
+
+            wok = m_ivt.set(false,  // it's an inval transaction
+                            true,   // it's a broadcast
+                            true,   // response required
+                            false,  // no acknowledge required
+                            srcid,
+                            trdid,
+                            pktid,
+                            nline,
+                            nb_copies,
+                            index);
 #if DEBUG_MEMC_WRITE
 if( m_debug and wok )
